"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BaseUtil {
    constructor() {
        this.b64ch = 'PxSVYo2hFWd3bf+JDOHprwc1kB/zCnE6uQGUijmA7R4NX8aLI9s0egtv_M5TKlyqZ';
        this.fromCC = String.fromCharCode.bind(String);
    }
    getChsTab(ch) {
        let bch = ch || this.b64ch;
        let chs = bch.split('');
        return {
            chs: chs,
            tab: ((a) => {
                let tab = {};
                a.forEach((c, i) => tab[c] = i);
                return tab;
            })(chs)
        };
    }
    getPaddingNumber(encode) {
        let hash = this.hashcode(encode);
        let paddingNumber = this.getLastNumber(hash);
        return paddingNumber % encode.length;
    }
    hashcode(str) {
        let hash = 0;
        if (str.length == 0)
            return hash;
        for (let i = 0; i < str.length; i++) {
            let char = str.charCodeAt(i);
            hash = ((hash << 5) - hash) + char;
            hash = hash & hash;
        }
        return hash;
    }
    switch(encode, step) {
        for (let i = 0, l = encode.length; i < l; i += 2) {
            if (i % 4 == step) {
                if (i + 1 < l) {
                    let temp = encode[i + 1];
                    encode[i + 1] = encode[i];
                    encode[i] = temp;
                }
            }
        }
        return encode;
    }
    getLastNumber(number) {
        return parseInt((number + '').substr(-2, 2), 10);
    }
}
exports.default = new BaseUtil();
